# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from .analysis_cost_analysis_type import AnalysisCostAnalysisType
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AnalysisCost(UniversalBaseModel):
    type: typing.Literal["analysis"] = pydantic.Field(default="analysis")
    """
    This is the type of cost, always 'analysis' for this class.
    """

    analysis_type: typing_extensions.Annotated[AnalysisCostAnalysisType, FieldMetadata(alias="analysisType")] = (
        pydantic.Field()
    )
    """
    This is the type of analysis performed.
    """

    model: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    This is the model that was used to perform the analysis.
    """

    prompt_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="promptTokens")] = pydantic.Field()
    """
    This is the number of prompt tokens used in the analysis.
    """

    completion_tokens: typing_extensions.Annotated[float, FieldMetadata(alias="completionTokens")] = pydantic.Field()
    """
    This is the number of completion tokens generated in the analysis.
    """

    cost: float = pydantic.Field()
    """
    This is the cost of the component in USD.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
