# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from .summary_plan import SummaryPlan
from ..core.serialization import FieldMetadata
import pydantic
from .structured_data_plan import StructuredDataPlan
from .success_evaluation_plan import SuccessEvaluationPlan
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AnalysisPlan(UniversalBaseModel):
    summary_plan: typing_extensions.Annotated[typing.Optional[SummaryPlan], FieldMetadata(alias="summaryPlan")] = (
        pydantic.Field(default=None)
    )
    """
    This is the plan for generating the summary of the call. This outputs to `call.analysis.summary`.
    """

    structured_data_plan: typing_extensions.Annotated[
        typing.Optional[StructuredDataPlan], FieldMetadata(alias="structuredDataPlan")
    ] = pydantic.Field(default=None)
    """
    This is the plan for generating the structured data from the call. This outputs to `call.analysis.structuredData`.
    """

    success_evaluation_plan: typing_extensions.Annotated[
        typing.Optional[SuccessEvaluationPlan], FieldMetadata(alias="successEvaluationPlan")
    ] = pydantic.Field(default=None)
    """
    This is the plan for generating the success evaluation of the call. This outputs to `call.analysis.successEvaluation`.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
