# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from .analytics_query_group_by_item import AnalyticsQueryGroupByItem
from ..core.serialization import FieldMetadata
from .time_range import TimeRange
from .analytics_operation import AnalyticsOperation
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AnalyticsQuery(UniversalBaseModel):
    table: typing.Literal["call"] = pydantic.Field(default="call")
    """
    This is the table you want to query.
    """

    group_by: typing_extensions.Annotated[
        typing.Optional[typing.List[AnalyticsQueryGroupByItem]], FieldMetadata(alias="groupBy")
    ] = pydantic.Field(default=None)
    """
    This is the list of columns you want to group by.
    """

    name: str = pydantic.Field()
    """
    This is the name of the query. This will be used to identify the query in the response.
    """

    time_range: typing_extensions.Annotated[typing.Optional[TimeRange], FieldMetadata(alias="timeRange")] = (
        pydantic.Field(default=None)
    )
    """
    This is the time range for the query.
    """

    operations: typing.List[AnalyticsOperation] = pydantic.Field()
    """
    This is the list of operations you want to perform.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
