# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
from .artifact_messages_item import ArtifactMessagesItem
import pydantic
import typing_extensions
from .open_ai_message import OpenAiMessage
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class Artifact(UniversalBaseModel):
    messages: typing.Optional[typing.List[ArtifactMessagesItem]] = pydantic.Field(default=None)
    """
    These are the messages that were spoken during the call.
    """

    messages_open_ai_formatted: typing_extensions.Annotated[
        typing.Optional[typing.List[OpenAiMessage]], FieldMetadata(alias="messagesOpenAIFormatted")
    ] = pydantic.Field(default=None)
    """
    These are the messages that were spoken during the call, formatted for OpenAI.
    """

    recording_url: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="recordingUrl")] = (
        pydantic.Field(default=None)
    )
    """
    This is the recording url for the call. To enable, set `assistant.artifactPlan.recordingEnabled`.
    """

    stereo_recording_url: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="stereoRecordingUrl")
    ] = pydantic.Field(default=None)
    """
    This is the stereo recording url for the call. To enable, set `assistant.artifactPlan.recordingEnabled`.
    """

    video_recording_url: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="videoRecordingUrl")] = (
        pydantic.Field(default=None)
    )
    """
    This is video recording url for the call. To enable, set `assistant.artifactPlan.videoRecordingEnabled`.
    """

    video_recording_start_delay_seconds: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="videoRecordingStartDelaySeconds")
    ] = pydantic.Field(default=None)
    """
    This is video recording start delay in ms. To enable, set `assistant.artifactPlan.videoRecordingEnabled`. This can be used to align the playback of the recording with artifact.messages timestamps.
    """

    transcript: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the transcript of the call. This is derived from `artifact.messages` but provided for convenience.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
