# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from .client_message_conversation_update_messages_item import ClientMessageConversationUpdateMessagesItem
import typing_extensions
from .open_ai_message import OpenAiMessage
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ClientMessageConversationUpdate(UniversalBaseModel):
    type: typing.Literal["conversation-update"] = pydantic.Field(default="conversation-update")
    """
    This is the type of the message. "conversation-update" is sent when an update is committed to the conversation history.
    """

    messages: typing.Optional[typing.List[ClientMessageConversationUpdateMessagesItem]] = pydantic.Field(default=None)
    """
    This is the most up-to-date conversation history at the time the message is sent.
    """

    messages_open_ai_formatted: typing_extensions.Annotated[
        typing.List[OpenAiMessage], FieldMetadata(alias="messagesOpenAIFormatted")
    ] = pydantic.Field()
    """
    This is the most up-to-date conversation history at the time the message is sent, formatted for OpenAI.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
