# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
from .json_schema_type import JsonSchemaType
import pydantic
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class JsonSchema(UniversalBaseModel):
    type: JsonSchemaType = pydantic.Field()
    """
    This is the type of output you'd like.
    
    `string`, `number`, `integer`, `boolean` are the primitive types and should be obvious.
    
    `array` and `object` are more interesting and quite powerful. They allow you to define nested structures.
    
    For `array`, you can define the schema of the items in the array using the `items` property.
    
    For `object`, you can define the properties of the object using the `properties` property.
    """

    items: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = pydantic.Field(default=None)
    """
    This is required if the type is "array". This is the schema of the items in the array.
    
    This is of type JsonSchema. However, Swagger doesn't support circular references.
    """

    properties: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = pydantic.Field(default=None)
    """
    This is required if the type is "object". This specifies the properties of the object.
    
    This is a map of string to JsonSchema. However, Swagger doesn't support circular references.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the description to help the model understand what it needs to output.
    """

    required: typing.Optional[typing.List[str]] = pydantic.Field(default=None)
    """
    This is a list of properties that are required.
    
    This only makes sense if the type is "object".
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
