# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ..core.pydantic_utilities import UniversalBaseModel
from .callback_step import CallbackStep
from .create_workflow_block_dto import CreateWorkflowBlockDto
from .handoff_step import HandoffStep
import typing
from .server_message_response_assistant_request_destination import ServerMessageResponseAssistantRequestDestination
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
from .create_assistant_dto import CreateAssistantDto
from .assistant_overrides import AssistantOverrides
from .create_squad_dto import CreateSquadDto
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.pydantic_utilities import update_forward_refs


class ServerMessageResponseAssistantRequest(UniversalBaseModel):
    destination: typing.Optional[ServerMessageResponseAssistantRequestDestination] = pydantic.Field(default=None)
    """
    This is the destination to transfer the inbound call to. This will immediately transfer without using any assistants.
    
    If this is sent, `assistantId`, `assistant`, `squadId`, and `squad` are ignored.
    """

    assistant_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="assistantId")] = (
        pydantic.Field(default=None)
    )
    """
    This is the assistant that will be used for the call. To use a transient assistant, use `assistant` instead.
    """

    assistant: typing.Optional[CreateAssistantDto] = pydantic.Field(default=None)
    """
    This is the assistant that will be used for the call. To use an existing assistant, use `assistantId` instead.
    
    If you're unsure why you're getting an invalid assistant, try logging your response and send the JSON blob to POST /assistant which will return the validation errors.
    """

    assistant_overrides: typing_extensions.Annotated[
        typing.Optional[AssistantOverrides], FieldMetadata(alias="assistantOverrides")
    ] = pydantic.Field(default=None)
    """
    These are the overrides for the `assistant` or `assistantId`'s settings and template variables.
    """

    squad_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="squadId")] = pydantic.Field(
        default=None
    )
    """
    This is the squad that will be used for the call. To use a transient squad, use `squad` instead.
    """

    squad: typing.Optional[CreateSquadDto] = pydantic.Field(default=None)
    """
    This is a squad that will be used for the call. To use an existing squad, use `squadId` instead.
    """

    error: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the error if the call shouldn't be accepted. This is spoken to the customer.
    
    If this is sent, `assistantId`, `assistant`, `squadId`, `squad`, and `destination` are ignored.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(CallbackStep, ServerMessageResponseAssistantRequest=ServerMessageResponseAssistantRequest)
update_forward_refs(CreateWorkflowBlockDto, ServerMessageResponseAssistantRequest=ServerMessageResponseAssistantRequest)
update_forward_refs(HandoffStep, ServerMessageResponseAssistantRequest=ServerMessageResponseAssistantRequest)
