# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ToolCallMessage(UniversalBaseModel):
    role: str = pydantic.Field()
    """
    The role of the tool call in the conversation.
    """

    tool_calls: typing_extensions.Annotated[
        typing.List[typing.Dict[str, typing.Optional[typing.Any]]], FieldMetadata(alias="toolCalls")
    ] = pydantic.Field()
    """
    The list of tool calls made during the conversation.
    """

    message: str = pydantic.Field()
    """
    The message content for the tool call.
    """

    time: float = pydantic.Field()
    """
    The timestamp when the message was sent.
    """

    seconds_from_start: typing_extensions.Annotated[float, FieldMetadata(alias="secondsFromStart")] = pydantic.Field()
    """
    The number of seconds from the start of the conversation.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
