# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
from .condition import Condition
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ToolMessageDelayed(UniversalBaseModel):
    type: typing.Literal["request-response-delayed"] = pydantic.Field(default="request-response-delayed")
    """
    This message is triggered when the tool call is delayed.
    
    There are the two things that can trigger this message:
    
    1. The user talks with the assistant while your server is processing the request. Default is "Sorry, a few more seconds."
    2. The server doesn't respond within `timingMilliseconds`.
    
    This message is never triggered for async tool calls.
    """

    timing_milliseconds: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="timingMilliseconds")
    ] = pydantic.Field(default=None)
    """
    The number of milliseconds to wait for the server response before saying this message.
    """

    content: str = pydantic.Field()
    """
    This is the content that the assistant says when this message is triggered.
    """

    conditions: typing.Optional[typing.List[Condition]] = pydantic.Field(default=None)
    """
    This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
