# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
from .condition import Condition
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ToolMessageFailed(UniversalBaseModel):
    type: typing.Literal["request-failed"] = pydantic.Field(default="request-failed")
    """
    This message is triggered when the tool call fails.
    
    This message is never triggered for async tool calls.
    
    If this message is not provided, the model will be requested to respond.
    
    If this message is provided, only this message will be spoken and the model will not be requested to come up with a response. It's an exclusive OR.
    """

    end_call_after_spoken_enabled: typing_extensions.Annotated[
        typing.Optional[bool], FieldMetadata(alias="endCallAfterSpokenEnabled")
    ] = pydantic.Field(default=None)
    """
    This is an optional boolean that if true, the call will end after the message is spoken. Default is false.
    
    @default false
    """

    content: str = pydantic.Field()
    """
    This is the content that the assistant says when this message is triggered.
    """

    conditions: typing.Optional[typing.List[Condition]] = pydantic.Field(default=None)
    """
    This is an optional array of conditions that the tool call arguments must meet in order for this message to be triggered.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
