# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
import typing
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UserMessage(UniversalBaseModel):
    role: str = pydantic.Field()
    """
    The role of the user in the conversation.
    """

    message: str = pydantic.Field()
    """
    The message content from the user.
    """

    time: float = pydantic.Field()
    """
    The timestamp when the message was sent.
    """

    end_time: typing_extensions.Annotated[float, FieldMetadata(alias="endTime")] = pydantic.Field()
    """
    The timestamp when the message ended.
    """

    seconds_from_start: typing_extensions.Annotated[float, FieldMetadata(alias="secondsFromStart")] = pydantic.Field()
    """
    The number of seconds from the start of the conversation.
    """

    duration: typing.Optional[float] = pydantic.Field(default=None)
    """
    The duration of the message in seconds.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
