# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
from ..core.serialization import FieldMetadata
import pydantic
import typing
import datetime as dt
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class VonageCredential(UniversalBaseModel):
    vonage_application_private_key: typing_extensions.Annotated[
        str, FieldMetadata(alias="vonageApplicationPrivateKey")
    ] = pydantic.Field()
    """
    This is not returned in the API.
    """

    provider: typing.Literal["vonage"] = "vonage"
    api_secret: typing_extensions.Annotated[str, FieldMetadata(alias="apiSecret")] = pydantic.Field()
    """
    This is not returned in the API.
    """

    id: str = pydantic.Field()
    """
    This is the unique identifier for the credential.
    """

    org_id: typing_extensions.Annotated[str, FieldMetadata(alias="orgId")] = pydantic.Field()
    """
    This is the unique identifier for the org that this credential belongs to.
    """

    created_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="createdAt")] = pydantic.Field()
    """
    This is the ISO 8601 date-time string of when the credential was created.
    """

    updated_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="updatedAt")] = pydantic.Field()
    """
    This is the ISO 8601 date-time string of when the assistant was last updated.
    """

    vonage_application_id: typing_extensions.Annotated[str, FieldMetadata(alias="vonageApplicationId")] = (
        pydantic.Field()
    )
    """
    This is the Vonage Application ID for the credential.
    
    Only relevant for Vonage credentials.
    """

    api_key: typing_extensions.Annotated[str, FieldMetadata(alias="apiKey")]

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
